' --------------------------------------------------------
' OpenGL Keyboard Control Demo by Don [don67geo@yahoo.com]
' Compiled and tested under HotBasic v3.3b
' --------------------------------------------------------
$apptype   GUI
$typecheck ON

'-- keyboard virtual code
$define VK_ESCAPE 27
$define VK_F1     &H70
$define VK_LEFT   37
$define VK_RIGHT  39
$define VK_DOWN   40
$define VK_UP     38
$define VK_PGDN   &H22
$define VK_PGUP   &H21

'-- OpenGL contants
$define GL_COLOR_BUFFER_BIT &H00004000
$define GL_DEPTH_BUFFER_BIT &H00000100
$define GL_DEPTH_TEST       &H0B71
$define GL_PROJECTION       &H1701
$define GL_MODELVIEW        &H1700
$define GL_TRIANGLES        &H0004

'-- Pixel color constants
$define PFD_MAIN_PLANE      0
$define PFD_TYPE_RGBA       0
$define PFD_DOUBLEBUFFER    &H01
$define PFD_DRAW_TO_WINDOW  &H04
$define PFD_SUPPORT_OPENGL  &H20

'-- the twin sister of PIXELFORMATDESRIPTOR
TYPE LAYERPLANEDESCRIPTOR
  nSize             AS WORD
  nVersion          AS WORD
  dwFlags           AS DWORD
  iPixelType        AS BYTE
  cColorBits        AS BYTE
  cRedBits          AS BYTE
  cRedShift         AS BYTE
  cGreenBits        AS BYTE
  cGreenShift       AS BYTE
  cBlueBits         AS BYTE
  cBlueShift        AS BYTE
  cAlphaBits        AS BYTE
  cAlphaShift       AS BYTE
  cAccumBits        AS BYTE
  cAccumRedBits     AS BYTE
  cAccumGreenBits   AS BYTE
  cAccumBlueBits    AS BYTE
  cAccumAlphaBits   AS BYTE
  cDepthBits        AS BYTE
  cStencilBits      AS BYTE
  cAuxBuffers       AS BYTE
  iLayerPlane       AS BYTE
  bReserved         AS BYTE
  crTransparent     AS DWORD
END TYPE

' import gdi32.dll - color managements
declare function ChoosePixelFormat   lib "gdi32" (dw1 as dword,dw2 as dword) as dword
declare      sub SetPixelFormat      lib "gdi32" (dw1 as dword,dw2 as dword,dw3 as dword)
declare      sub DescribePixelFormat lib "gdi32" (dw1 as dword,dw2 as dword,dw3 as dword,dw4 as dword)
' import opengl32.dll - drawing operations
declare      sub glBegin           lib "opengl32" (dw1 as dword)
declare      sub glClear           lib "opengl32" (dw1 as dword)
declare      sub glClearColor      lib "opengl32" (ds1 as single, ds2 as single, ds3 as single, ds4 as single)
declare      sub glEnable          lib "opengl32" (dw1 as dword)
declare      sub glEnd             lib "opengl32" ()
declare      sub glColor3f         lib "opengl32" (ds1 as single, ds2 as single, ds3 as single)
declare      sub glRotatef         lib "opengl32" (ds1 as single, ds2 as single, ds3 as single, ds4 as single)
declare      sub glVertex3i        lib "opengl32" (dw1 as dword, dw2 as dword, dw3 as dword)
declare      sub glViewport        lib "opengl32" (dl1 as integer, dl2 as integer, dl3 as integer, dl4 as integer)
declare      sub glLoadIdentity    lib "opengl32" ()
declare      sub glMatrixMode      lib "opengl32" (dw1 as dword)
declare      sub glIndexi          lib "opengl32" (dw1 as dword)
declare      sub glPushMatrix      lib "opengl32" ()
declare      sub glTranslatef      lib "opengl32" (ds1 as single, ds2 as single, ds3 as single)
declare      sub glFlush           lib "opengl32" ()
declare      sub glPopMatrix       lib "opengl32" ()
' import opengl32.dll - gui engines
declare function wglCreateContext  lib "opengl32" (dw1 as dword) as dword
declare      sub wglDeleteContext  lib "opengl32" (dw1 as dword)
declare      sub wglMakeCurrent    lib "opengl32" (dw1 as dword, dw2 as dword)
declare      sub wglSwapBuffers    lib "opengl32" (dw1 as dword)
' import glul32.dll - gui enhancement
declare      sub gluPerspective    lib "glu32"    (dw1 as dword,dw2 as dword,dw3 as dword,dw4 as dword,dw5 as dword,dw5 as dword,dw7 as dword,dw8 as dword)

'- API assitant for DOUBLE types
declare sub glu_Perspective(fovy as double, aspect as double, zNear as double, zFar as double)

'- User procedures
declare sub reshape (iw as integer, ih as integer)
declare sub clamp   (dn as integer)
declare sub display ()
declare sub initgl  ()

dim pfd as LAYERPLANEDESCRIPTOR
dim trans(3) as single
dim rotat(2) as single
defsng thrust    = 0.3
defsng manoeuver = 3
defint mx,my,cDC,hRC,dx,dy,upd,pf

App.icon = "gl.ico"

'-- user interface here
create GW as FORM
  caption       = "OpenGL Keyboard Demo"
  center
  width         = 400
  height        = 320
  create GC as CANVAS
    top         = 0
    left        = 0
    width       = GW.clientwidth
    height      = GW.clientheight
    onpaint     = display
  end create
  create stb as STATUSBAR
    text        = "F1 - help | Esc - Quit"
  end create
  onshow        = GWCreate
  onkeydown     = GWKeyDown
  onkeyup       = GWKeyUp
  onresize      = GWSize
  onclose       = GWDestroy
end create

'-- Setting up pixel colors --
cDC = GC.GetDC

pfd.nSize        = sizeof(pfd)
pfd.nVersion     = 1
pfd.dwFlags      = PFD_DRAW_TO_WINDOW OR PFD_DOUBLEBUFFER OR PFD_SUPPORT_OPENGL
pfd.iLayerPlane  = PFD_MAIN_PLANE
pfd.iPixelType   = PFD_TYPE_RGBA
pfd.cDepthBits   = 24
pfd.cColorBits   = 16
pfd.cAccumBits   = 0
pfd.cStencilBits = 0
  
pf = ChoosePixelFormat(cDC, @pfd)
SetPixelFormat(cDC, pf, @pfd)
DescribePixelFormat(cDC, pf, pfd.nSize, @pfd)

GC.ReleaseDC
'-- Setting up pixel colors --

GW.showmodal
end

SUB glu_Perspective(fovy as double, aspect as double, zNear as double, zFar as double)
    '-- thanks to doctor electron for this DOUBLE assitances
    ASM lea esi,zFar  : ASM push [esi+4]: ASM push [esi]
    ASM lea esi,zNear : ASM push [esi+4]: ASM push [esi]
    ASM lea esi,aspect: ASM push [esi+4]: ASM push [esi]
    ASM lea esi,fovy  : ASM push [esi+4]: ASM push [esi]
    ASM call gluPerspective
END SUB

sub clamp(dn as integer)
    '-- angle and roatation safe guards
    if dn > 360.0 then
       dn = dn - 360.0 
    elseif dn < -360.0 then 
       dn = dn + 360.0
    else
       dn = dn
    end if
end sub

sub initgl
    glEnable(GL_DEPTH_TEST)
end sub

sub reshape(iw as integer, ih as integer)
    aspect = iw/ih
    '-- the elders and smorfs who take care the new worlds changes
    glViewport(0, 0, iw, ih)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    glu_Perspective(60.0,aspect,0.001,100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    glTranslatef(0.0, 0.0, -3.0)
end sub

sub display
    '-- clear GL scene and set to colors
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)

    '-- positioning mode for 3d model
    glPushMatrix()
    glTranslatef(trans(0), trans(1), trans(2))

    '-- rotations ability with 2 axis turn
    glRotatef(rotat(0), 1.0, 0.0, 0.0)
    glRotatef(rotat(1), 0.0, 1.0, 0.0)

    '-- change background color
    glClearColor(0.18,0.18,0.38,0.0)

    '-- begin drawing with triangle base
    glBegin(GL_TRIANGLES)

    '-- the 3d drawing begin here
    glIndexi(1): glColor3f(1.0, 0.0, 0.0): glVertex3i( 0,  1,  0)
    glIndexi(3): glColor3f(0.0, 0.0, 1.0): glVertex3i(-1, -1,  1)
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i( 1, -1,  1)
    
    glIndexi(1): glColor3f(1.0, 0.0, 0.0): glVertex3i( 0,  1,  0)
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i( 1, -1,  1)
    glIndexi(3): glColor3f(0.0, 0.0, 1.0): glVertex3i( 1, -1, -1)
    
    glIndexi(1): glColor3f(1.0, 0.0, 0.0): glVertex3i( 0,  1,  0)
    glIndexi(3): glColor3f(0.0, 0.0, 1.0): glVertex3i( 1, -1, -1)
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i(-1, -1, -1)
    
    glIndexi(1): glColor3f(1.0, 0.0, 0.0): glVertex3i( 0,  1,  0)
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i(-1, -1, -1)
    glIndexi(3): glColor3f(0.0, 0.0, 1.0): glVertex3i(-1, -1,  1)
    
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i( 1, -1,  1)
    glIndexi(3): glColor3f(0.0, 0.0, 1.0): glVertex3i(-1, -1,  1)
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i(-1, -1, -1)

    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i(-1, -1, -1)
    glIndexi(3): glColor3f(0.0, 0.0, 1.0): glVertex3i( 1, -1, -1)
    glIndexi(2): glColor3f(0.0, 1.0, 0.0): glVertex3i( 1, -1,  1)

    '-- end drawing token
    glEnd()
    glPopMatrix()

    '-- Flip the screen for GL scene refresh
    glFlush()
    wglSwapBuffers(cDC)
end sub

GWCreate:
  '-- open the GL stage curtain now!
  cDC = GC.GetDC
  hRC = wglCreateContext(cDC)
  wglMakeCurrent(cDC, hRC)
  initgl
  Return

GWKeyDown:
  select case wParam
    case &H5A, &H7A  'z and Z
         rotat(1) = rotat(1) - manoeuver
         clamp(rotat(1))
         stb.text = "Rotate to Right"
    case &H58, &H78  'x and X
         rotat(1) = rotat(1) + manoeuver
         clamp(rotat(1))
         stb.text = "Rotate to Left"
    case VK_DOWN
         trans(2) = trans(2) - thrust
         stb.text = "Moving Backward"
    case VK_UP
           trans(2) = trans(2) + thrust
         stb.text = "Moving Forward"
    case VK_RIGHT
         trans(0) = trans(0) - thrust
         stb.text = "Moving Right"
    case VK_LEFT
         trans(0) = trans(0) + thrust
         stb.text = "Moving Left"
    case VK_PGUP
         rotat(0) = rotat(0) + manoeuver
         clamp(rotat(0))
         stb.text = "Rotate Upward"
    case VK_PGDN
         rotat(0) = rotat(0) - manoeuver
         clamp(rotat(0))
         stb.text = "Rotate Downward"
    case VK_F1
         goto GWInfo
         stb.text = "Reading ship user manual"
    case VK_ESCAPE
         GW.close
    case else
         '-- Engineering! change the ship speed...
         if (wParam >= 49 OR wParam < 57) then
            manoeuver = wParam - 48
            thrust    = manoeuver / 10
         end if
         stb.text = "Warp speed: " + str$(manoeuver)
  end select
  '-- non-flicker repaint (use with care)
  upd = PostMessage(GC, &HF, 0, 0)
 return

GWKeyUp:
  stb.text = "F1 - Help | " + stb.text
  return

GWInfo:
  ShowMessage _
      "OpenGL Keyboard Control Demo"        + CRLF + _
      "by Don [don67geo@yahoo.com]"         + CRLF + _
      "**************************************" + CRLF + _
      CRLF + _
      "Ship Controls:" + CRLF + _
      "****************" + CRLF + _
      "UP    " + TAB + "- Move Forward"     + CRLF + _
      "DOWN  " + TAB + "- Reverse backward" + CRLF + _
      "LEFT  " + TAB + "- Pan to left"      + CRLF + _
      "RIGHT " + TAB + "- Pan to right"     + CRLF + _
      CRLF + _
      "Ship Rotations:" + CRLF + _
      "*****************" + CRLF + _
      "z, Z  " + TAB + "- Rotate to left"   + CRLF + _
      "x, X  " + TAB + "- Rotate to right"  + CRLF + _
      "PGUP  " + TAB + "- Rotate upward"    + CRLF + _
      "PGDN  " + TAB + "- Rotate downward"  + CRLF + _
      CRLF + _
      "Warp Speeds:" + CRLF + _
      "****************" + CRLF + _
      "1 to 9" + TAB + "- Warp speed"       + CRLF + _
      CRLF + _
      "ESC   " + TAB + "- Quit the program"
  GW.focus
  return

GWSize:
  GC.width = GW.clientwidth
  GC.height = GW.clientheight - stb.height
  '-- update GL scene
  reshape(GC.width, GC.height)
  '-- non-flicker repaint (use with care)
  upd = PostMessage(GC, &HF, 0, 0)
  display
  return

GWDestroy:
  '-- usual stuffs, garbage cleaner
  if hRC then
     wglMakeCurrent(0, 0)
     wglDeleteContext(hRC)
  end if
  GC.ReleaseDC
  App.Terminate
  Return

